---
title: Intl.DateTimeFormat.prototype.format()
slug: Web/JavaScript/Reference/Global_Objects/Intl/DateTimeFormat/format
tags:
  - DateTimeFormat
  - Internationalization
  - Intl
  - JavaScript
  - Method
  - Prototype
---
<div>{{JSRef}}</div>

<p>The <strong><code>Intl.DateTimeFormat.prototype.format()</code></strong> method formats a date according to the locale and formatting options of this {{jsxref("DateTimeFormat", "Intl.DateTimeFormat")}} object.</p>

<div>{{EmbedInteractiveExample("pages/js/intl-datetimeformat-prototype-format.html", "taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>dateTimeFormat</var>.format(<var>date</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>date</var></code></dt>
 <dd>The date to format.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>The <code>format</code> getter formats a date into a string according to the locale and formatting options of this {{jsxref("DateTimeFormat", "Intl.DateTimeFormat")}} object.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_format">Using format</h3>

<p>Use the <code>format</code> getter function for formatting a single date, here for Serbia:</p>

<pre class="brush: js notranslate">var options = { weekday: 'long', year: 'numeric', month: 'long', day: 'numeric' };
var dateTimeFormat = new Intl.DateTimeFormat('sr-RS', options);
console.log(dateTimeFormat.format(new Date()));
// → "недеља, 7. април 2013."
</pre>

<h3 id="Using_format_with_map">Using format with map</h3>

<p>Use the <code>format</code> getter function for formatting all dates in an array. Note that the function is bound to the {{jsxref("DateTimeFormat", "Intl.DateTimeFormat")}} from which it was obtained, so it can be passed directly to {{jsxref("Array.prototype.map()")}}.</p>

<pre class="brush: js notranslate">var a = [new Date(2012, 08), new Date(2012, 11), new Date(2012, 03)];
var options = { year: 'numeric', month: 'long' };
var dateTimeFormat = new Intl.DateTimeFormat('pt-BR', options);
var formatted = a.map(dateTimeFormat.format);
console.log(formatted.join('; '));
// → "setembro de 2012; dezembro de 2012; abril de 2012"
</pre>

<h3 id="Avoid_comparing_formatted_date_values_to_static_values">Avoid comparing formatted date values to static values</h3>

<p>Most of the time, the formatting returned by <code>format()</code> is consistent. However, this might change in the future and isn't guaranteed for all the languages — output variations are by design and allowed by the specification. Most notably, the IE and Edge browsers insert bidirectional control characters around dates, so the output text will flow properly when concatenated with other text.</p>

<p>For this reason you cannot expect to be able to compare the results of <code>format()</code> to a static value:</p>

<pre class="brush: js; example-bad notranslate">let d = new Date("2019-01-01T00:00:00.000000Z");
let formattedDate = Intl.DateTimeFormat(undefined, {
  year: 'numeric',
  month: 'numeric',
  day: 'numeric',
  hour: 'numeric',
  minute: 'numeric',
  second: 'numeric'
}).format(d);

"1.1.2019, 01:00:00" === formattedDate;
// true in Firefox and others
// false in IE and Edge
</pre>

<div class="notecard note">
<p><strong>Note</strong>: See also this <a href="https://stackoverflow.com/questions/25574963/ies-tolocalestring-has-strange-characters-in-results">StackOverflow thread</a> for more details and examples.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ES Int Draft', '#sec-intl.datetimeformat.prototype.format', 'Intl.DateTimeFormat.format')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Intl.DateTimeFormat.format")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Global_Objects/DateTimeFormat", "Intl.DateTimeFormat")}}</li>
 <li>{{jsxref("Date.prototype.toLocaleString()")}}</li>
 <li>{{jsxref("Date.prototype.toLocaleDateString()")}}</li>
 <li>{{jsxref("Date.prototype.toLocaleTimeString()")}}</li>
</ul>
